# Guidelime_Zarant

## Overview
This is primarily an in-game alliance hunter/warlock speed leveling guide for Classic WoW written as an addon module for Guidelime. 

This guide is suitable for other classes as well, however, you might have to skip some elite quests and incorporate class specific quests into your route since they are not taken into account, such as the Whirlwind Axe quest, rogue poison quest, just to name a few.

If you need pointers on how to do the more techincal stuff like soloing elite quests or executing some of the wall jumps, you can watch the last 1-60 run I recorded [here](https://www.speedrun.com/wowclassic/run/y4w7elqm),  additionally you can check out my Twitch channel ([http://www.twitch.tv/Zarant_](http://www.twitch.tv/Zarant_)) for more Classic WoW speedrunning related stuff.

## Setup
- Download and install this addon, if you are downloading from GitHub make sure to remove the `-master` from the folder name.
- Download and install [Guidelime](https://www.curseforge.com/wow/addons/Guidelime)
- Make sure you enable both `Guidelime` and `Guidelime_Zarant` before logging in
- Once you log in, press ESC to open the options menu, click on Interface Options, switch to the AddOns tab, select Guidelime from the list on the left and then scroll down to select the guide you want to load.

Due to some limitations with Guidelime, some steps have to be completed manually, if you wish to enable step auto completion, you need to edit the `Guidelime.toc` file after installing Guidelime and add the following line at the end:

`..\Guidelime_Zarant\Loader.xml`

## Feedback
If you have questions, suggestions or any form of constructive criticism you can either open a ticket [here](https://github.com/Zarant/Guidelime_Zarant/issues) or message me on [Discord](https://discord.gg/aBzxhDh).

This guide was mainly written for personal use and being a veteran player, I omitted some information to keep it concise. If you feel like some key information is missing from a particular section, please let me know. 

## FAQ

I get a lot of questions from people starting this guide from some arbitrary level and curious to know how to pick it up from the middle, there is no easy way to answer this question, some zones are broken down into several level ranges (e.g. STV), some quest chains span several zones and since this is a mainly a speedrunning guide, I try to minimize travel time as much as possible.

 The way this guide is set up, it's broken down into 4 independent chunks:

* The first segment is from 1-23 (starting zone to Ashenvale).
* The second segment is from 23-32 (Wetlands to Duskwood)
* The third segment is from 32-43 (Hillsbrad to late STV)
* The fourth segment starts with Tanaris/Feralas and you can start it anywhere between level 43 and 48.

If you start any of those segments at the level I suggested, the XP loss from skipping any quests that you don't have is minimal. Some of the sections are largely self contained but some other sections rely on doing long quest chains with a lot of travel involved.